package models

import (
	"pro2d/common/components"
	"pro2d/pb"
)

type AccountModel struct {
	components.ISchema
	*pb.Account
}

func AccountExistByPhone(phone string) (bool, *AccountModel){
	m := NewAccount(phone)
	if err := m.Load(); err != nil {
		return false, m
	}
	return true, m
}

func NewAccount(phone string) *AccountModel {
	ac := &pb.Account{
		Phone: phone,

	}

	account := &AccountModel{
		ISchema:  NewSchema(phone, ac),
		Account: ac,
	}

	return account
}