package models

import (
	"fmt"
	"pro2d/common"
	"pro2d/common/db/mongoproxy"
	"pro2d/common/logger"
	"pro2d/pb"
	"strings"
	"testing"
)

func TestNewRole(t *testing.T) {
	err := mongoproxy.ConnectMongo(common.GlobalConf.GameConf.MongoConf, common.GlobalConf.GameConf.ID)
	if err != nil {
		logger.Error(err)
		return
	}

	var uid = "141815055745814528"
	role := RoleExistByUid(uid)
	if role != nil {
		//uid存在 ， 更新角色
		//role.AddHero(&pb.Data{
		//	Id:         1,
		//	RoleId:     role.Data.Id,
		//	Type:       0,
		//	Level:      0,
		//	ReinCount:  0,
		//	ReinPoint:  0,
		//	Equipments: "",
		//})
		role.SetProperty("Device", "1111")
		//role.Save()
	} else {
		//uid不存在，创建角色
		role = NewRole("1")
		role.Data.Uid = uid
		role.Data.Device = "111111"
		role.Data.Level = 0
		err := role.Create()
		fmt.Println(err)
	}
	print(role)
}

func TestRoleIndex(t *testing.T) {
	coll, keys := mongoproxy.FindIndex(pb.Role{})
	for _, index := range keys {
		logger.Debug("coll: %s, key: %s", coll, index)
	}
}

func TestRoleModel_AddHero(t *testing.T) {
	err := mongoproxy.ConnectMongo(common.GlobalConf.GameConf.MongoConf, common.GlobalConf.GameConf.ID)
	if err != nil {
		logger.Error(err)
		return
	}

	var uid = "141815055745814528"
	role := RoleExistByUid(uid)
	if role == nil {
		logger.Error("role not exist")
		return
	}

	role.InitRole()
}

func TestRoleModel_ProtoReflect(t *testing.T) {
	err := mongoproxy.ConnectMongo(common.GlobalConf.GameConf.MongoConf, common.GlobalConf.GameConf.ID)
	if err != nil {
		logger.Error(err)
		return
	}

	sch := NewRole("")
	//mp := map[string]interface{}{
	//	"Id": "1",
	//	"Device": "12312312312",
	//}
	sch.UpdateProperty("Device", "123123123", false)
	fmt.Println(sch.Data)
}

func TestRoleModel_UpdateTeam(t *testing.T) {
	err := mongoproxy.ConnectMongo(common.GlobalConf.GameConf.MongoConf, common.GlobalConf.GameConf.ID)
	if err != nil {
		logger.Error(err)
		return
	}
	sch := NewRole("1")
	sch.Load()
	sch.LoadAll()
	sch.UpdateTeam([]*pb.Team{
		&pb.Team{
			Id:      "147262174025748480",
			RoleId:  "",
			HeroId1: "",
			HeroId2: "",
			HeroId3: "",
		},
	})
	sch.OnOfflineEvent()
}

func TestRoleModel_IncreByKey(t *testing.T) {
	//err := mongoproxy.ConnectMongo(common.GlobalConf.GameConf.MongoConf, common.GlobalConf.GameConf.ID)
	//if err != nil {
	//	logger.Error(err)
	//	return
	//}
	//sch := NewRole("1000001")
	//sch.Load()
	//sch.LoadAll()
	//
	//sch.Data.Incres["hero"] = 4
	//sch.Data.Incres["team"] = 4
	//sch.SetProperty("incres", sch.Data.Incres)
	//sch.Update()

	fmt.Printf("%03d\n", 3)

	ites := strings.SplitN("1=1 2=2 3=3", " ", -1)
	fmt.Println(ites)

}

func TestSchema_Create(t *testing.T) {
	_ = mongoproxy.ConnectMongo(common.GlobalConf.GameConf.MongoConf, common.GlobalConf.GameConf.ID)
	role := NewRole("")
	s := role.ISchema.(*Schema)
	logger.Debug(s.protoIndex)
}
